/*
 * Copyright (C) 1997-2005 P. Dular, C. Geuzaine
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA.
 *
 * Please report all bugs and problems to <getdp@geuz.org>.
 */

#ifndef _PRINT_PROBLEM_STRUCTURE_H_
#define _PRINT_PROBLEM_STRUCTURE_H_

void  Print_ProblemStructure(struct Problem  * Problem) ;
int   Print_Object(int ichoice, struct Problem * Problem) ;

void  Print_Group         (struct Problem  * Problem) ;
void  Print_Expression    (struct Problem  * Problem) ;
void  Print_Constraint    (struct Problem  * Problem) ;
void  Print_Jacobian      (struct Problem  * Problem) ;
void  Print_Integration   (struct Problem  * Problem) ;
void  Print_FunctionSpace (struct Problem  * Problem) ;
void  Print_Formulation   (struct Problem  * Problem) ;
void  Print_Resolution    (struct Problem  * Problem) ;
void  Print_PostProcessing(struct Problem  * Problem) ;
void  Print_PostOperation (struct Problem  * Problem) ;

char * Print_PostSubOperation(struct Problem *Problem,
			      struct PostProcessing *PP,
			      struct PostSubOperation *PSO) ;

void  Print_ListResolution    (int choice, struct Problem  * Problem) ;
void  Print_ListPostOperation (int choice, struct Problem  * Problem) ;
void  Print_ListPostProcessing(int choice, struct Problem  * Problem) ;

#endif
